From 225ea21a23ff3a7fb3fec7d7f14445c0220f2fdf Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Nov 05 2020 22:49:10 +0000
Subject: [PATCH 1291/2232] Validate cfg


---

diff --git a/gen/build/src/error.rs b/gen/build/src/error.rs
index 069723b..877a973 100644
--- a/gen/build/src/error.rs
+++ b/gen/build/src/error.rs
@@ -11,6 +11,7 @@ pub(super) enum Error {
     NoEnv(OsString),
     Fs(fs::Error),
     ExportedDirNotAbsolute(&'static Path),
+    ExportedEmptyPrefix,
 }
 
 impl Display for Error {
@@ -25,6 +26,9 @@ impl Display for Error {
                 "element of CFG.exported_header_dirs must be absolute path, but was: {:?}",
                 path,
             ),
+            Error::ExportedEmptyPrefix => {
+                f.write_str("element of CFG.exported_header_prefixes must not be empty string")
+            }
         }
     }
 }
diff --git a/gen/build/src/lib.rs b/gen/build/src/lib.rs
index 21e4ea8..066b458 100644
--- a/gen/build/src/lib.rs
+++ b/gen/build/src/lib.rs
@@ -176,6 +176,8 @@ impl Project {
 // current build as well as for downstream builds that have a direct dependency
 // on the current crate.
 fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Result<Build> {
+    validate_cfg()?;
+
     let ref prj = Project::init()?;
     let this_crate = make_this_crate(prj)?;
     this_crate.print_to_cargo();
@@ -201,6 +203,22 @@ fn build(rust_source_files: &mut dyn Iterator<Item = impl AsRef<Path>>) -> Resul
     Ok(build)
 }
 
+fn validate_cfg() -> Result<()> {
+    for exported_dir in &CFG.exported_header_dirs {
+        if !exported_dir.is_absolute() {
+            return Err(Error::ExportedDirNotAbsolute(exported_dir));
+        }
+    }
+
+    for prefix in &CFG.exported_header_prefixes {
+        if prefix.is_empty() {
+            return Err(Error::ExportedEmptyPrefix);
+        }
+    }
+
+    Ok(())
+}
+
 fn make_this_crate(prj: &Project) -> Result<Crate> {
     let crate_dir = make_crate_dir(prj);
     let include_dir = make_include_dir(prj)?;
@@ -228,9 +246,6 @@ fn make_this_crate(prj: &Project) -> Result<Crate> {
     }
 
     for exported_dir in &CFG.exported_header_dirs {
-        if !exported_dir.is_absolute() {
-            return Err(Error::ExportedDirNotAbsolute(exported_dir));
-        }
         this_crate.header_dirs.push(HeaderDir {
             exported: true,
             path: PathBuf::from(exported_dir),

